

// TODO: for adding different activity types
var ActivityVerb =
{
    Post : 1,
    View : 2,
    Publish : 3,
    Share : 4,
    Like : 5
}

// TODO: add detail and acitivy stream objects like subject, verb and object
function ActivityModel(title, summary)
{
    this.title = title;
    this.summary = summary;

    this.id = null;
}

function ActivityStream()
{
    var _prefKey = "_activity_stream";
    var _activityItems = [];
    var _maxItems = 30;
    var _idCounter = 0;
    var webserver = opera.io.webserver;
    var self = this;

    // receiving activity over the net
    function onPublishActivity(evt)
    {
        var request = evt.connection.request,
            response = evt.connection.response;
            
        var payLoad = request.getItem("payload");
        self.publish(payLoad);
        response.setStatusCode(200, "OK");
        response.close();
    }
    
    function onGetActivityFeed(evt)
    {
        var request = evt.connection.request,
            response = evt.connection.response;
            
        //response.setResponseHeader("Content-Type", "application/atom+xml")
        response.write(self.getAtom());
        response.close();
    }
    
    function onGetStub(evt)
    {
        var request = evt.connection.request,
            response = evt.connection.response;
            
        // TODO: load stub into client
        response.close();
    }
    
    function zp(n)
    {
        return ("00"+n).slice(-2);
    }
    
    function getAtomTime(time)
    {
        if (! time)
        {
            time = new Date();
        }
        
        return time.getFullYear() + "-" + zp(time.getMonth()) + "-" + zp(time.getDate()) + "T" + zp(time.getHours()) + ":" + zp(time.getMinutes()) + ":" + zp(time.getSeconds()) + "Z";
        
    }
    
    function init()
    {
       if (webserver)
       {
            // TODO: For reporting activiy over-the-air
            //webserver.addEventListener('publishActivity', onPublishActivity, false); 
            webserver.addEventListener('activityFeed', onGetActivityFeed, false);
            // TODO: For serving stub to report activity
            //webserver.addEventListener('stub.js', onGetStub, false); 
       }
       load(); 
    }                            
                
    function load()
    {
        //widget.setPreferenceForKey("", _prefKey);
        var tmpData = widget.preferenceForKey(_prefKey);
        _idCounter = widget.preferenceForKey(_prefKey + "_counter");
        if (! _idCounter)
        {
            _idCounter = 0;
        }
        _activityItems = (tmpData) ? JSON.parse(tmpData) : [];
    }
    
    function save()
    {
        if (_activityItems.length > _maxItems)
        {
            _activityItems = _activityItems.slice(_activityItems.length - _maxItems - 1);
        }
        var tmpData = JSON.stringify(_activityItems);
        opera.postError("Saving " + tmpData);
        widget.setPreferenceForKey(tmpData, _prefKey);
        widget.setPreferenceForKey(_idCounter, _prefKey + "_counter");
    }
    
    function getFeedURL()
    {
        // fixme: not good enoguh
        return "http://" +  webserver.hostName + webserver.currentServicePath;
    }
    
    function getEntryURI(activityItem)
    {
        return "tag:" + webserver.currentServiceName + "." + webserver.hostName + "," + activityItem.id;
    }
   
    // Plan is to include more parameters 
    this.publish = function(title, summary)
    {
        var am = new ActivityModel(title, summary);
        am.id = _idCounter++;
        am.created = am.updated = getAtomTime();
        _activityItems.push(am);
        save();
    }
    
    this.getAtom = function()
    {
        var a = ['<?xml version="1.0" encoding="utf-8"?>',
                 '<feed xmlns="http://www.w3.org/2005/Atom">',
                    '<title>' + webserver.currentServiceName + ' activity stream </title>',
                    '<id>' +  getFeedURL() + '</id>'];

        for (var i = _activityItems.length - 1; i > 0;i--)
        {
            a.push('<entry>',
                       '<title>' + _activityItems[i].title + '</title>',
                       '<id>' + getEntryURI(_activityItems[i]) + '</id>',
                       '<updated>' + _activityItems[i].updated + '</updated>');
            
            a.push('</entry>');
        }
        a.push('</feed>');
        
        return a.join('\n');
    }
    
    init();
}