/* preloading */
(function() {
    (new Image).src = 'images/edit_note.png';
})();

function Wall() {

    var conf = {
        ACTION : document.forms.shout.action?document.forms.shout.action:'#',
        POLL_INTERVAL : 25    // in sec
    };

    var revision = (new Date()).valueOf();
    var isReadonly = false;
    
    var elCapacity = document.getElementById('capacity');
    var isAdmin = !!elCapacity;
    if (isAdmin) {
        var capacity = elCapacity.value;
    }
    
    var form = document.forms.shout;
    var shoutbox = document.getElementById('shoutBox');
    
    function addRemoveListeners() {
        var trashButtons = document.getElementsByName('delete');
        
        for (var i=0, button; button = trashButtons[i]; ++i) {
            if (button.onclick !== sendRemoveRequest) { 
                button.onclick = sendRemoveRequest; 
            }
        }
    };

    function sendRemoveRequest(e) {
        e = e || window.event;
        e.preventDefault = e.preventDefault || function() { 
            this.returnValue = false; 
        };

        var sBody = 'remove='+this.previousSibling.value;

        keepOn(sBody);

        e.preventDefault();
        return;
    };    
    
    function refreshDates() {
        var noteForms = document.getElementsByClassName('note_form');
        var now = new Date;
        for (var i=0, ntForm; ntForm = noteForms[i]; ++i)
            getElementsByClassName.call(ntForm.parentNode,'date')[0].innerHTML
                = (new Date(parseInt(ntForm.remove.value))).happens(now);
    };
    
    function removeNotes(remove) {
        for (var s = 0, sDate; sDate = remove[s]; ++s) {

            var noteForms = document.getElementsByClassName('note_form');
            for (var i = 0, ntForm; ntForm = noteForms[i]; ++i) {
                if (ntForm.remove.value == sDate) {

                    // against IE memory leaks
                    // if (ntForm['delete']) { 
                    //     ntForm['delete'].onclick = null; 
                    // }
                    purge(ntForm.parentNode, true);

                    ntForm.parentNode.parentNode.removeChild(
                        ntForm.parentNode
                    );
                    break;
                }
            }
        }
    };
    
    function onChangeReadonly() {
        if (isAdmin) { return };
        
        for (var i = 0, el; el = form.elements[i]; ++i) {
            el.disabled = isReadonly;
        }
        
        // js - animate in future releases?
        document.getElementById('add_note_wrapper').style.display
            = isReadonly ? 'none' : 'block'; 
    };
    
    function onSuccessfulResponse(xhr) {

        // --- HEADERS
        
        // ------ Fatal-error, Error
        var error;
        
        // There are errors that should prevent auto-request; these
        // will be signified be 'Fatal-error' header.
        if (error = xhr.getResponseHeader('Fatal-error')) {
            clearTimeout(oTimeout);
            xhr.abort();
        
            document.body.innerHTML = error + ' Please, try again later.';
            return;
        }
        if (error = xhr.getResponseHeader('Error')) {
            alert(error);
        }
        
        // ------ Revision, PrevRevision
        var prevRevision = parseInt(xhr.getResponseHeader('Prev-revision'));
        var newRevision = parseInt(xhr.getResponseHeader('Revision'));
        
        // when admin closes the service, FF receives malformed headers:
        if (isNaN(newRevision) || isNaN(prevRevision)) { return }
        
        // ------ Revision, PrevRevision
        // if it's first request or readonly attribute changed - change 
        // the form appropriately
        var hdrReadonly = (xhr.getResponseHeader('Readonly') == 'false')
            ? false : true;
        if (revision > newRevision || hdrReadonly != isReadonly) {
            isReadonly = hdrReadonly;
            onChangeReadonly()
        }
        
        // ------ Capacity
        if (isAdmin) {
            var newCapacity = parseInt(xhr.getResponseHeader('Capacity'));
            if (newCapacity != capacity && !isNaN(newCapacity)) {
                capacity = newCapacity;
                elCapacity.value = capacity;
            }
        }
        
        // ------ Revision, PrevRevision
        var remove = xhr.getResponseHeader('Remove');
        if (remove) { removeNotes(remove.split(',')); }
        
        // --- BODY

        // if it's fresh request or there where no other changes meanwhile
        // just append the response; otherwise parse the whole content
        if (revision >= prevRevision) {
        
            // var frag = document.createDocumentFragment();
            // for (var i = 0, child; child = shoutbox.childNodes[i]; ) {
            //     frag.appendChild(child);
            // };
            // shoutbox.innerHTML = xhr.responseText;
            // for (var i = 0, child; child = frag.childNodes[i]; ) {
            //     shoutbox.appendChild(child);
            // }
            
            // or:
            purge(shoutbox, true, ['onclick']);
            shoutbox.innerHTML = xhr.responseText + shoutbox.innerHTML;    
        } else {
            purge(shoutbox, true, ['onclik']);
            shoutbox.innerHTML = xhr.responseText;
        }
        addRemoveListeners();
        
        // ---
        
        revision = newRevision;
        keepOn();
    };
    
    
    var oTimeout = null;
    var xhr = { abort : function(){} };
    function keepOn(sBody) {
        clearTimeout(oTimeout);
        
        xhr.abort();
        
        refreshDates();
        
        sBody = sBody || null;
        
        xhr = sendRequest(sBody);
        oTimeout = setTimeout( keepOn , conf.POLL_INTERVAL*1000 );
    };
    
    function sendRequest(sBody, callback) {

        var xhr = new XMLHttpRequest();
        
        xhr.onreadystatechange = function() {
            // this won't work for ie6; use explicit variable: xhr
            var self = xhr; // this
            if (self.readyState == 4) {
                if (self.status == 200) {
                    onSuccessfulResponse(self);
                }
            }
        };

        xhr.open('POST', '#', true);
        
        xhr.setRequestHeader('Revision', revision );

        xhr.setRequestHeader(
            'Content-Type', 
            'application/x-www-form-urlencoded; charset=utf-8'
        );

        xhr.send(sBody);
        
        return xhr;
    };

    this.keepOn = keepOn;
    
    function __init__() {
        refreshDates();
        addRemoveListeners();
    };
    
    __init__();
};


//--- event functions out of scope

function onBlur(msg, func) {
    return function() {
        if (!this.value) {
            this.className = 'empty';
            this.value = msg;
            if (func) { func.call(this) };
        }
    }
};

function onFocus() {        
    if (this.className == 'empty') {
        this.className = '';
        this.value = '';
    }
};

addEvent(window, 'load', function() {

    window.oWall = new Wall();
    
    conf = {
        MAX_POST_LENGTH : 85,
        FONT_MIN : 27,
        FONT_MAX : 60,
        WELCOME_MSG_POST : 'Введи текст тут...',
        WELCOME_MSG_AUTHOR : '... подпишись...',
        WELCOME_MSG_EMAIL : 'и введи e-mail',
        EMPTY_ERR_MSG : 'Пустые сообщения некорректны!'
    };

    // --- CREATE & FIND
    
    // html elements
    var charsLeft = document.getElementById('charsLeft'),
        textarea = document.forms.shout.post,
        email = document.getElementById('email'),
        author = document.getElementById('author'),
        addNote = document.getElementById('add_note'),
        shoutForm = document.forms.shout;
    
    var lightboxShade = document.createElement('div');    
    lightboxShade.id = 'lightbox_shade';
    document.body.appendChild(lightboxShade);

    // functions
    function editModeOn() {
        lightboxShade.style.display = 'block';
        shoutForm.style.display = 'block';
    /*
        // animation to be refined in future
        lightboxShade.style.opacity = 0;
        shoutForm.style.opacity = 0;
        lightboxShade.style.display = 'block';
        shoutForm.style.display = 'block';
        var steps = 4;
        var to = 50;
        var i = 0;
        (function() {
            ++i
            var opacity = i/steps;
            if (opacity > 1) { opacity = 1 }
            lightboxShade.style.opacity = opacity/2;
            shoutForm.style.opacity = opacity;
            if (opacity < 1) {
                setTimeout(arguments.callee, to);
            }
        })();
    */
    };
    
    function editModeOff() {
        lightboxShade.style.display = 'none';
        shoutForm.style.display = 'none';
    /*
        // animation to be refined in future
        var steps = 4;
        var to = 50;
        var i = steps;
        (function() {
            --i;
            var opacity = i/steps;
            if (opacity < 0) { opacity = 0 }
            lightboxShade.style.opacity = opacity/2;
            shoutForm.style.opacity = opacity;
            if (opacity > 0) {
                setTimeout(arguments.callee, to);
            } else {
                lightboxShade.style.display = 'none';
                shoutForm.style.display = 'none';
            }
        })();
    */
    };
    
    // --- INIT
    
    // inputs onblur
    author.onblur = onBlur(conf.WELCOME_MSG_AUTHOR);
    email.onblur = onBlur(conf.WELCOME_MSG_EMAIL);
    
    //> leak evt
    textarea.onblur = onBlur(conf.WELCOME_MSG_POST, function() {
        charsLeft.innerHTML = conf.MAX_POST_LENGTH;
        this.setFont();
    });

    // inputs onfocus
    author.onfocus = email.onfocus = onFocus;
    //> leak evt
    textarea.onfocus = function() {
        onFocus.call(this);
        this.onclick();
    };
    
    // font resizing
    var fontSetter = window.getFontSetter(textarea, conf.FONT_MIN, conf.FONT_MAX);
    //> leak prop
    textarea.setFont = function() {
        var fontSize = fontSetter.computeFont(
            this.value.replace(/\n/g,'<br/>').replace(/  /g, ' &nbsp;')
        );
        this.style.fontSize = fontSize + 'px';
        return fontSize;
    };
    
    // update 'chars left' div and font size
    //var scrollTimeout;
    textarea.onchange = textarea.onclick = textarea.onkeyup = function() {
        clearTimeout(arguments.callee.scrollTimeout);
            
        if (this.value.length > conf.MAX_POST_LENGTH) {
            this.value = this.value.substring(0, conf.MAX_POST_LENGTH);
        }

        var iLeft = conf.MAX_POST_LENGTH - this.value.length;
        charsLeft.innerHTML = iLeft;
        charsLeft.style.color = 'rgb('
            +(255-(iLeft/conf.MAX_POST_LENGTH)*255 >> 0)
            +',0,'
            +((iLeft/conf.MAX_POST_LENGTH)*255 >> 0)
            +')';

        var fontSize = this.setFont();

        // max lines message ?
        var maxlines = 1, lines = 0;
        if (fontSize == conf.FONT_MIN) {
        
            var styles = window.getComputedStyle(this);
            lineHeight = parseInt(styles.getPropertyValue('line-height'));

            if (isNaN(lineHeight)) { lineHeight = 1.5 * fontSize };
            
            maxlines = (this.clientHeight / lineHeight) >> 0;
            lines = (this.scrollHeight / lineHeight) >> 0;
            
            if (lines > maxlines) {
                var msg = '&nbsp;&nbsp;' + maxlines + ' lines maximum, please :)';
                charsLeft.innerHTML += msg;
            }
        }
        
        // convenience issue for Opera (it scrolls stuff for some reason)
        if (maxlines >= lines) {
            var self = this;
            arguments.callee.scrollTimeout 
                = setTimeout(function(){ self.scrollTop = 0; }, 999);
        }

    };
    
/*
    // TAB key make 4 spaces
    textarea.getSelectionRange = getSelectionRange;
    if (!textarea.setSelectionRange) {
        textarea.setSelectionRange = window.setSelectionRange;
    }
    textarea.onkeydown = function(e) {
        e = e || window.event;
        if (e.keyCode == 9) { // tab -> 4 spaces
            var range = this.getSelectionRange();
            var start = range[0];
            var end = range[1];

            this.value = this.value.substr(0, start)
                + '    ' + this.value.substr(end);
                
            var self = this;
            setTimeout( function() { 
                self.focus();
                self.setSelectionRange(start+4, start+4);
            }, 200 );
        }
    };
*/
    // animate add_note button click
    //> leak evt
    addNote.onmousedown = function() {
        this.parentNode.parentNode.style.top = '0px';
    };
    addNote.onmouseup = function() {
        this.parentNode.parentNode.style.top = '';
    };
    
    // show/hide new note editing
    addNote.onclick = editModeOn;
    lightboxShade.onclick = editModeOff;
    document.getElementById('cancel').onclick = editModeOff;

    // ie bug: Enter won't submit
    // NOTICE: submit button must be there for this to work!
    // (it can't be 'display: none' nor 'visibility: hidden')
    author.onkeydown = email.onkeydown = function (e) {
        if (!e && window.event) { 
            if (window.event.keyCode == 13) {
                sendPost.call(shoutForm, {preventDefault : function(){}});
                return false;
            }
        }
    };
        
    
    // --- START ---

    textarea.value = '';
    textarea.onblur();
    
    // in FF conf.WELCOME_MSGs are remembered and put as defaults 
    // for some reason. For that, server sets 'empty' class for
    // inputs with no value...
    if (author.getAttribute('class') == 'empty') {
        author.value = '';
        author.onblur();
    }
    if (email.getAttribute('class') == 'empty') {
        email.value = '';
        email.onblur();
    }
    
    lightboxShade.onclick();    //???
    
    
    // --- COMMUNICATION
    
    function sendPost(e) { 
        if (textarea.className == 'empty') {
            alert(conf.EMPTY_ERR_MSG);
            e.preventDefault();
            return;
        }
        
        if (author.className == 'empty') { author.value = ''; }
        if (email.className == 'empty') { email.value = ''; }
        
        // build request's body
        var sBody, sParam, aBody = [];
        for (var i=0, el; el = this.elements[i]; ++i) {
            sParam = encodeURIComponent(el.name);
            sParam += '=';
            sParam += encodeURIComponent(el.value);
            aBody.push(sParam);
        }
        sBody = aBody.join('&');

        oWall.keepOn(sBody) 
        
        // clear editing area
        textarea.value = '';
        textarea.onblur();
        author.onblur();
        email.onblur();
        
        editModeOff();
        
        // we don't want to submit the form
        e.preventDefault();

    };
    
    // onsubmit
    addEvent(document.forms.shout,'submit', sendPost, false);
    
    // start polling
    oWall.keepOn();
    
    // --- JAM LEAKS
    
    addEvent(window, 'unload', function() {

        // unleak prop
        purge(textarea);
        purge(addNote);
        purge(author);
        purge(email)

    });
    
}, false);
